updated android_ndk_defconfig
[oweals/busybox.git] / scripts / trylink
index 8c8854679be80d0294ebb3e807c3a446a1fa8933..48c487bcd30f92f3029bf7f18a704da15a498264 100755 (executable)
@@ -46,19 +46,19 @@ try() {
 }
 
 check_cc() {
-    local tempname="/tmp/temp.$$.$RANDOM"
+    local tempname="$(mktemp)"
     # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
     # "-xc": C language. "/dev/null" is an empty source file.
-    if $CC $1 -shared -xc /dev/null -o "$tempname".o >/dev/null 2>&1; then
+    if $CC $CPPFLAGS $CFLAGS $1 -shared -xc /dev/null -o "$tempname".o >/dev/null 2>&1; then
        echo "$1";
     else
        echo "$2";
     fi
-    rm "$tempname".o 2>/dev/null
+    rm -f "$tempname" "$tempname".o
 }
 
 check_libc_is_glibc() {
-    local tempname="/tmp/temp.$$.$RANDOM"
+    local tempname="$(mktemp)"
     echo "\
        #include <stdlib.h>
        /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
@@ -66,12 +66,12 @@ check_libc_is_glibc() {
        syntax error here
        #endif
        " >"$tempname".c
-    if $CC "$tempname".c -c -o "$tempname".o >/dev/null 2>&1; then
+    if $CC $CPPFLAGS $CFLAGS "$tempname".c -c -o "$tempname".o >/dev/null 2>&1; then
        echo "$2";
     else
        echo "$1";
     fi
-    rm "$tempname".c "$tempname".o 2>/dev/null
+    rm -f "$tempname" "$tempname".[co]
 }
 
 EXE="$1"
@@ -85,6 +85,13 @@ LDLIBS="$7"
 # The --sort-section option is not supported by older versions of ld
 SORT_SECTION=`check_cc "-Wl,--sort-section,alignment" ""`
 
+START_GROUP="-Wl,--start-group"
+END_GROUP="-Wl,--end-group"
+INFO_OPTS="-Wl,--warn-common -Wl,-Map,$EXE.map -Wl,--verbose"
+
+# gold may not support --sort-common (yet)
+SORT_COMMON=`check_cc "-Wl,--sort-common" ""`
+
 # Static linking against glibc produces buggy executables
 # (glibc does not cope well with ld --gc-sections).
 # See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
@@ -110,14 +117,14 @@ LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
 # First link with all libs. If it fails, bail out
 echo "Trying libraries: $LDLIBS"
 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
-l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
-test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
+l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
+test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
 try $CC $CFLAGS $LDFLAGS \
        -o $EXE \
-       -Wl,--sort-common \
+       $SORT_COMMON \
        $SORT_SECTION \
        $GC_SECTIONS \
-       -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
+       $START_GROUP $O_FILES $A_FILES $END_GROUP \
        $l_list \
 || {
     echo "Failed: $l_list"
@@ -134,15 +141,15 @@ while test "$LDLIBS"; do
     for one in $LDLIBS; do
        without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
        # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
-       l_list=`echo "$without_one" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
-       test x"$l_list" != x"" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
+       l_list=`echo " $without_one " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
+       test x"$l_list" != x"" && l_list="$START_GROUP $l_list $END_GROUP"
        $debug && echo "Trying -l options: '$l_list'"
        try $CC $CFLAGS $LDFLAGS \
                -o $EXE \
-               -Wl,--sort-common \
+               $SORT_COMMON \
                $SORT_SECTION \
                $GC_SECTIONS \
-               -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
+               $START_GROUP $O_FILES $A_FILES $END_GROUP \
                $l_list
        if test $? = 0; then
            echo " Library $one is not needed, excluding it"
@@ -165,20 +172,18 @@ done
 
 # Make the binary with final, minimal list of libs
 echo "Final link with: ${LDLIBS:-<none>}"
-l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
-test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
+l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
+test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
 # --verbose gives us gobs of info to stdout (e.g. linker script used)
 if ! test -f busybox_ldscript; then
     try $CC $CFLAGS $LDFLAGS \
            -o $EXE \
-           -Wl,--sort-common \
+           $SORT_COMMON \
            $SORT_SECTION \
            $GC_SECTIONS \
-           -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
+           $START_GROUP $O_FILES $A_FILES $END_GROUP \
            $l_list \
-           -Wl,--warn-common \
-           -Wl,-Map,$EXE.map \
-           -Wl,--verbose \
+           $INFO_OPTS \
     || {
        cat $EXE.out
        exit 1
@@ -193,15 +198,13 @@ else
     # Hmm, "ld --sort-section alignment" should do it too.
     try $CC $CFLAGS $LDFLAGS \
            -o $EXE \
-           -Wl,--sort-common \
+           $SORT_COMMON \
            $SORT_SECTION \
            $GC_SECTIONS \
            -Wl,-T,busybox_ldscript \
-           -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
+           $START_GROUP $O_FILES $A_FILES $END_GROUP \
            $l_list \
-           -Wl,--warn-common \
-           -Wl,-Map,$EXE.map \
-           -Wl,--verbose \
+           $INFO_OPTS \
     || {
        cat $EXE.out
        exit 1
@@ -228,13 +231,11 @@ if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
            -Wl,-z,combreloc \
            -Wl,-soname="libbusybox.so.$BB_VER" \
            -Wl,--undefined=lbb_main \
-           -Wl,--sort-common \
+           $SORT_COMMON \
            $SORT_SECTION \
-           -Wl,--start-group $A_FILES -Wl,--end-group \
+           $START_GROUP $A_FILES $END_GROUP \
            $l_list \
-           -Wl,--warn-common \
-           -Wl,-Map,$EXE.map \
-           -Wl,--verbose \
+           $INFO_OPTS \
     || {
        echo "Linking $EXE failed"
        cat $EXE.out
@@ -249,14 +250,13 @@ if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
     EXE="$sharedlib_dir/busybox_unstripped"
     try $CC $CFLAGS $LDFLAGS \
            -o $EXE \
-           -Wl,--sort-common \
+           $SORT_COMMON \
            $SORT_SECTION \
            $GC_SECTIONS \
-           -Wl,--start-group $O_FILES -Wl,--end-group \
+           $START_GROUP $O_FILES $END_GROUP \
            -L"$sharedlib_dir" -lbusybox \
-           -Wl,--warn-common \
-           -Wl,-Map,$EXE.map \
-           -Wl,--verbose \
+           $l_list \
+           $INFO_OPTS \
     || {
        echo "Linking $EXE failed"
        cat $EXE.out
@@ -268,7 +268,7 @@ fi
 
 if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
     echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
-    gcc -DNAME_MAIN_CNAME -E -include include/autoconf.h include/applets.h \
+    gcc -DNAME_MAIN -E -include include/autoconf.h include/applets.h \
     | grep -v "^#" \
     | grep -v "^$" \
     > applet_lst.tmp
@@ -288,7 +288,7 @@ int main(int argc, char **argv)
        EXE="$sharedlib_dir/$name"
        try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
                -o $EXE \
-               -Wl,--sort-common \
+               $SORT_COMMON \
                $SORT_SECTION \
                $GC_SECTIONS \
                -L"$sharedlib_dir" -lbusybox \
@@ -300,6 +300,8 @@ int main(int argc, char **argv)
        }
        rm -- "$sharedlib_dir/applet.c" $EXE.out
        $STRIP -s --remove-section=.note --remove-section=.comment $EXE
+       # Let user see that we do something - list the names of created binaries:
+       echo "$EXE"
 
     done <applet_lst.tmp
 fi